'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.type = undefined;
exports.get = get;
exports.getNode = getNode;

var _graphql = require('graphql');

var graphql = _interopRequireWildcard(_graphql);

var _graphqlRelay = require('graphql-relay');

var relay = _interopRequireWildcard(_graphqlRelay);

var _relayNode = require('../relayNode');

var _withType = require('../withType');

var _withType2 = _interopRequireDefault(_withType);

var _ = require('.');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const type = exports.type = new graphql.GraphQLObjectType({
  name: 'Viewer',
  fields: () => ({
    id: relay.globalIdField('Viewer', () => 'viewer'),
    agencies: (() => {
      const { connectionType } = relay.connectionDefinitions({
        name: _.agency.type.name,
        nodeType: _.agency.type
      });
      return {
        type: connectionType,
        args: relay.connectionArgs,
        resolve(query, args, context) {
          return _asyncToGenerator(function* () {
            const agencies = yield _.agency.getAll(context);
            return relay.connectionFromArray(agencies, args);
          })();
        }
      };
    })(),
    agency: {
      type: _.agency.type,
      args: {
        tag: { type: graphql.GraphQLString }
      },
      resolve(query, { tag }, context, info) {
        return _asyncToGenerator(function* () {
          return _.agency.get(tag, context, info);
        })();
      }
    }
  }),
  interfaces: () => [_relayNode.nodeInterface]
});

function get() {
  return (0, _withType2.default)(type.name, {});
}

function getNode(id) {
  return get(id);
}